/////////////////////////////////////////////////////////////////////////////////////////////
// This file is compiled with WinAVR version 4.1.2
//
// These routines mess with the stack
//
// you must use either of these optimizations:
// -O1
// -O3
// -O2
//
// Whatever you do, do NOT use -O0....it will NOT work
//
// /////////////////////////////////////////////////////////////////////////////////////////

#include "task.h"
#include "pq.h"

/*********************************************************************
** This function is used to yield (please note that the function name
** is misspelled on purpose, there is a Yield funciton somewhere in the
** IAR library) control of the processor to another task, but only if
** we are at the task level.  We cannot yield if we are in an interrupt
** routine
*********************************************************************/

void Yeild(void)
{
	char sr;

	if(!InterruptCount)
	{
		sr = Disable();
		CurrentTask->TimeStamp = TStamp;
		Replace(&ActiveTasks,(void **)&NextTask,(void *)CurrentTask);
		NextTask->TcbSwaps++;
		DoSwap();
		Enable(sr);
	}
}
