// BaudRate.h: interface for the BaudRate class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_BAUDRATE_H__3A4D84CB_E0A5_4D30_910E_75C341ED00C3__INCLUDED_)
#define AFX_BAUDRATE_H__3A4D84CB_E0A5_4D30_910E_75C341ED00C3__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

enum {BR_300,BR_1200,BR_2400,BR_4800,BR_9600,BR_14400,BR_19200,BR_38400,BR_57600,BR_115200};

class BaudRate  
{
public:
	char * GetComPortName(int ComPort);
	int GetBaudRateIndex(int BR);
	BaudRate();
	virtual ~BaudRate();
	int GetBaudRate(int BRIndex);
private:
	int m_MaxBRIndex;
};

#endif // !defined(AFX_BAUDRATE_H__3A4D84CB_E0A5_4D30_910E_75C341ED00C3__INCLUDED_)
