// SerialSetup.cpp : implementation file
//

#include "stdafx.h"
#include "synthconsol.h"
#include "SerialSetup.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSerialSetup dialog


CSerialSetup::CSerialSetup(CWnd* pParent /*=NULL*/)
	: CDialog(CSerialSetup::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSerialSetup)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CSerialSetup::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSerialSetup)
	DDX_Control(pDX, IDC_COMBO_COMPORT, m_Combo_Port);
	DDX_Control(pDX, IDC_COMBO_BAUDRATE, m_Combo_BaudRate);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSerialSetup, CDialog)
	//{{AFX_MSG_MAP(CSerialSetup)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSerialSetup message handlers

void CSerialSetup::OnOK() 
{
	// TODO: Add extra validation here
	m_BaudRate = m_Combo_BaudRate.GetCurSel();
	m_ComPort = m_Combo_Port.GetCurSel();
	
	CDialog::OnOK();
}

BOOL CSerialSetup::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	int i;
	char *s = new char[256];
	int br,loop;

	for(i=0,loop=1;loop;++i)
	{
		br = BR.GetBaudRate(i);
		if(br > 0)
		{
			sprintf(s,"%d",br);
			m_Combo_BaudRate.InsertString(i,s);
		}
		else
			loop = 0;
	}
	m_Combo_BaudRate.SetCurSel(m_BaudRate);
	for(i=0;i<14;++i)
	{
		sprintf(s,"COM%d",i+1);
		m_Combo_Port.InsertString(i,s);
	}
	m_Combo_Port.SetCurSel(m_ComPort);
	delete[] s;
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
