`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    20:02:00 09/28/2008 
// Design Name: 
// Module Name:    DualPortRam512x3 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module DualPortRam512x3(a, d, dpra, clk, we, spo, dpo);
    input [8:0] a;
    input [2:0] d;
    input [8:0] dpra;
    input clk;
    input we;
    output [2:0] spo;
    output [2:0] dpo;

	wire [2:0] spo,dpo;
	
DualPortRam512x1 r0 (
    .a(a), 
    .d(d[0]), 
    .dpra(dpra), 
    .clk(clk), 
    .we(we), 
    .spo(spo[0]), 
    .dpo(dpo[0])
    );
DualPortRam512x1 r1 (
    .a(a), 
    .d(d[1]), 
    .dpra(dpra), 
    .clk(clk), 
    .we(we), 
    .spo(spo[1]), 
    .dpo(dpo[1])
    );
DualPortRam512x1 r2 (
    .a(a), 
    .d(d[2]), 
    .dpra(dpra), 
    .clk(clk), 
    .we(we), 
    .spo(spo[2]), 
    .dpo(dpo[2])
    );

endmodule
