`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    08:13:44 02/07/2007 
// Design Name: 
// Module Name:    baudrategen 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module baudrategen(clk, reset, R, BR);
    input clk;			//system clock
    input reset;		//system reset
    input [15:0] R;	//sixteen bit word to control baudrate
    output BR;	//bit rate output

	wire BR;		//bit rate output
	reg [15:0] Raccumulator;	//rate accumulator
	reg D;
	
	always @ (posedge clk or posedge reset) begin
		if(reset)
			Raccumulator <= 0;
		else
			Raccumulator <= Raccumulator + R;
	end

	always @ (posedge clk) D <= Raccumulator[15];
	assign BR = D & !Raccumulator[15];
	
endmodule
