`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    08:38:13 04/30/2008 
// Design Name: 
// Module Name:    bcdINC 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module bcdINC(
    input clk,			//system clock
    input reset,		//system reset
    input [7:0] I,	//data input
    output [7:0] O,	//count output
    input E,			//load enable
    input C,				//count enable
	 output V		//count overflow
    );

	parameter BCD_MAX		=	8'h59;
	reg [7:0] ldval;
	reg ld;
	
	
	always @(O or I) begin
		if(O == BCD_MAX)
			ldval = 0;
		else
			ldval = I;
	end
	
	always @(E or O or C)
		if((O == BCD_MAX) && C)
			ld = 1;
		else if (E)
			ld = 1;
		else
			ld = 0;
			
dec8cntr Digit (
    .clk(clk), 
    .reset(reset),
	 .M(BCD_MAX),
    .I(ldval), 
    .O(O), 
    .L(ld), 
    .C(C), 
    .V(V)
    );
			
endmodule
