`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    14:52:58 02/08/2007 
// Design Name: 
// Module Name:    dpr16x8 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module dpr16x8(clk, we, D, A, SPO, DPRA, DPO);
    input clk;
	 input we;
    input [7:0] D;
	 input [3:0] A;
    output [7:0] SPO;
	input [3:0] DPRA;
	output [7:0] DPO;
	
   RAM16X1D #(
      .INIT(16'h0000) // Initial contents of RAM
   ) Ram0 (
      .DPO(DPO[0]),     // Read-only 1-bit data output for DPRA
      .SPO(SPO[0]),     // R/W 1-bit data output for A0-A3
      .A0((A[0])),       // R/W address[0] input bit
      .A1(A[1]),       // R/W address[1] input bit
      .A2(A[2]),       // R/W address[2] input bit
      .A3(A[3]),       // R/W address[3] input bit
      .D(D[0]),         // Write 1-bit data input
      .DPRA0(DPRA[0]), // Read address[0] input bit
      .DPRA1(DPRA[1]), // Read address[1] input bit
      .DPRA2(DPRA[2]), // Read address[2] input bit
      .DPRA3(DPRA[3]), // Read address[3] input bit
      .WCLK(clk),   // Write clock input
      .WE(we)        // Write enable input
   );

   RAM16X1D #(
      .INIT(16'h0000) // Initial contents of RAM
   ) Ram1 (
      .DPO(DPO[1]),     // Read-only 1-bit data output for DPRA
      .SPO(SPO[1]),     // R/W 1-bit data output for A0-A3
      .A0(A[0]),       // R/W address[0] input bit
      .A1(A[1]),       // R/W address[1] input bit
      .A2(A[2]),       // R/W address[2] input bit
      .A3(A[3]),       // R/W address[3] input bit
      .D(D[1]),         // Write 1-bit data input
      .DPRA0(DPRA[0]), // Read address[0] input bit
      .DPRA1(DPRA[1]), // Read address[1] input bit
      .DPRA2(DPRA[2]), // Read address[2] input bit
      .DPRA3(DPRA[3]), // Read address[3] input bit
      .WCLK(clk),   // Write clock input
      .WE(we)        // Write enable input
   );
	
   RAM16X1D #(
      .INIT(16'h0000) // Initial contents of RAM
   ) Ram2 (
      .DPO(DPO[2]),     // Read-only 1-bit data output for DPRA
      .SPO(SPO[2]),     // R/W 1-bit data output for A0-A3
      .A0(A[0]),       // R/W address[0] input bit
      .A1(A[1]),       // R/W address[1] input bit
      .A2(A[2]),       // R/W address[2] input bit
      .A3(A[3]),       // R/W address[3] input bit
      .D(D[2]),         // Write 1-bit data input
      .DPRA0(DPRA[0]), // Read address[0] input bit
      .DPRA1(DPRA[1]), // Read address[1] input bit
      .DPRA2(DPRA[2]), // Read address[2] input bit
      .DPRA3(DPRA[3]), // Read address[3] input bit
      .WCLK(clk),   // Write clock input
      .WE(we)        // Write enable input
   );
   RAM16X1D #(
      .INIT(16'h0000) // Initial contents of RAM
   ) Ram3 (
      .DPO(DPO[3]),     // Read-only 1-bit data output for DPRA
      .SPO(SPO[3]),     // R/W 1-bit data output for A0-A3
      .A0(A[0]),       // R/W address[0] input bit
      .A1(A[1]),       // R/W address[1] input bit
      .A2(A[2]),       // R/W address[2] input bit
      .A3(A[3]),       // R/W address[3] input bit
      .D(D[3]),         // Write 1-bit data input
      .DPRA0(DPRA[0]), // Read address[0] input bit
      .DPRA1(DPRA[1]), // Read address[1] input bit
      .DPRA2(DPRA[2]), // Read address[2] input bit
      .DPRA3(DPRA[3]), // Read address[3] input bit
      .WCLK(clk),   // Write clock input
      .WE(we)        // Write enable input
   );
   RAM16X1D #(
      .INIT(16'h0000) // Initial contents of RAM
   ) Ram4 (
      .DPO(DPO[4]),     // Read-only 1-bit data output for DPRA
      .SPO(SPO[4]),     // R/W 1-bit data output for A0-A3
      .A0(A[0]),       // R/W address[0] input bit
      .A1(A[1]),       // R/W address[1] input bit
      .A2(A[2]),       // R/W address[2] input bit
      .A3(A[3]),       // R/W address[3] input bit
      .D(D[4]),         // Write 1-bit data input
      .DPRA0(DPRA[0]), // Read address[0] input bit
      .DPRA1(DPRA[1]), // Read address[1] input bit
      .DPRA2(DPRA[2]), // Read address[2] input bit
      .DPRA3(DPRA[3]), // Read address[3] input bit
      .WCLK(clk),   // Write clock input
      .WE(we)        // Write enable input
   );
   RAM16X1D #(
      .INIT(16'h0000) // Initial contents of RAM
   ) Ram5 (
      .DPO(DPO[5]),     // Read-only 1-bit data output for DPRA
      .SPO(SPO[5]),     // R/W 1-bit data output for A0-A3
      .A0(A[0]),       // R/W address[0] input bit
      .A1(A[1]),       // R/W address[1] input bit
      .A2(A[2]),       // R/W address[2] input bit
      .A3(A[3]),       // R/W address[3] input bit
      .D(D[5]),         // Write 1-bit data input
      .DPRA0(DPRA[0]), // Read address[0] input bit
      .DPRA1(DPRA[1]), // Read address[1] input bit
      .DPRA2(DPRA[2]), // Read address[2] input bit
      .DPRA3(DPRA[3]), // Read address[3] input bit
      .WCLK(clk),   // Write clock input
      .WE(we)        // Write enable input
   );
   RAM16X1D #(
      .INIT(16'h0000) // Initial contents of RAM
   ) Ram6 (
      .DPO(DPO[6]),     // Read-only 1-bit data output for DPRA
      .SPO(SPO[6]),     // R/W 1-bit data output for A0-A3
      .A0(A[0]),       // R/W address[0] input bit
      .A1(A[1]),       // R/W address[1] input bit
      .A2(A[2]),       // R/W address[2] input bit
      .A3(A[3]),       // R/W address[3] input bit
      .D(D[6]),         // Write 1-bit data input
      .DPRA0(DPRA[0]), // Read address[0] input bit
      .DPRA1(DPRA[1]), // Read address[1] input bit
      .DPRA2(DPRA[2]), // Read address[2] input bit
      .DPRA3(DPRA[3]), // Read address[3] input bit
      .WCLK(clk),   // Write clock input
      .WE(we)        // Write enable input
   );
   RAM16X1D #(
      .INIT(16'h0000) // Initial contents of RAM
   ) Ram7 (
      .DPO(DPO[7]),     // Read-only 1-bit data output for DPRA
      .SPO(SPO[7]),     // R/W 1-bit data output for A0-A3
      .A0(A[0]),       // R/W address[0] input bit
      .A1(A[1]),       // R/W address[1] input bit
      .A2(A[2]),       // R/W address[2] input bit
      .A3(A[3]),       // R/W address[3] input bit
      .D(D[7]),         // Write 1-bit data input
      .DPRA0(DPRA[0]), // Read address[0] input bit
      .DPRA1(DPRA[1]), // Read address[1] input bit
      .DPRA2(DPRA[2]), // Read address[2] input bit
      .DPRA3(DPRA[3]), // Read address[3] input bit
      .WCLK(clk),   // Write clock input
      .WE(we)        // Write enable input
   );

endmodule
