/*@A (C) 1992 Allen I. Holub                                                */
#ifndef __VIDEO_H
#define __VIDEO_H

#define NUMROWS		60
#define NUMCOLS		80

#define MONBASE		((volatile char *)0xc000)

typedef	struct
{
    unsigned char letter;
    unsigned char attribute;
} CHARACTER;


typedef CHARACTER  DISPLAY[NUMROWS][NUMCOLS];


#ifdef ALLOC
	DISPLAY *dv_Screen = (DISPLAY *) MONBASE ;
#else
	extern	DISPLAY *dv_Screen;
#endif

#define SCREEN 		(*dv_Screen)

typedef short		CHAR_ATTRIB;

typedef CHAR_ATTRIB	VDISPLAY[ NUMROWS ][ NUMCOLS ];

#define VSCREEN 	((VDISPLAY *)dv_Screen )


#endif /* __VIDEO_H */
