// Led.cpp : implementation file
//

#include "stdafx.h"
#include "Led.h"
#include "LedBitmaps.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


static const LedIDs[5] = {IDB_BITMAP_LEDOFF,
						IDB_BITMAP_REDON,IDB_BITMAP_REDOFF,
						IDB_BITMAP_GREENON,IDB_BITMAP_GREENOFF
};


/////////////////////////////////////////////////////////////////////////////
// CLed

CLed::CLed()
{
	int i;
	MaxLed = 5;
	LedBitMaps = new CBitmap*[MaxLed];

	for(i=0;i<MaxLed;++i)
	{
		LedBitMaps[i] = new CBitmap;
		LedBitMaps[i]->LoadBitmap(LedIDs[i]);
	}
}

CLed::~CLed()
{
	int i;

	for(i=0;i<MaxLed;++i)
	{
		delete LedBitMaps[i];
	}
	delete[] LedBitMaps;
}


BEGIN_MESSAGE_MAP(CLed, CStatic)
	//{{AFX_MSG_MAP(CLed)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLed message handlers

int CLed::SelectLed(int led)
{
	int retval = 1;
	if((led >= 0) && (led < MaxLed))
	{
		retval = 0;
		SetBitmap(HBITMAP(*LedBitMaps[led]) );
	}
	return retval;
}
