`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    13:14:57 07/06/2008 
// Design Name: 
// Module Name:    TrigCompare 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module TrigCompare(T, I, O);
    input [1:0] T;
    input I;
    output O;

	reg O;
	
	parameter TRIG_DNTC	=	2'b00;	//don't care
	parameter TRIG_ZERO	=	2'b10;
	parameter TRIG_ONE	=	2'b11;
	
	always @ (T or I) begin
		case(T)
			TRIG_DNTC:O = 1;			//don't care
			TRIG_ZERO:O = I?0:1;
			TRIG_ONE:O = I?1:0;
			default:O = 1;
		endcase
	end
	
endmodule
