`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    09:02:13 05/07/2008 
// Design Name: 
// Module Name:    dec8cntr 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module dec8cntr(
    input clk,
    input reset,
	 input [7:0] M,
    input [7:0] I,
    output reg [7:0] O,
    input L,
    input C,
	 output reg V
    );

	always @ (posedge clk or posedge reset) begin
		if(reset)
			O[3:0] <= 0;
		else begin
			if(L)
				O[3:0] <= I[3:0];
			else if (C) begin
				if(O[3:0] >= 9)
					O[3:0] <= 0;
				else
					O[3:0] <= O[3:0] + 1;
			end
		end
	end
	
	always @ (posedge clk or posedge reset) begin
		if(reset)
			O[7:4] <= 0;
		else begin
			if(L)
				O[7:4] <= I[7:4];
			else if (C && (O[3:0] >= 9)) begin
				if(O[7:4] >= 9)
					O[7:4] <= 0;
				else 
					O[7:4] <= O[7:4] + 1;
			end
		end
	end
	
	always @ (O or M or C)
			if((O == M) && C)
			V = 1;
		else
			V = 0;
	
	
endmodule
