////////////////////////////////////////////////////////////////////////////////
//   ____  ____  
//  /   /\/   /  
// /___/  \  /   
// \   \   \/    
//  \   \        Copyright (c) 2003-2004 Xilinx, Inc.
//  /   /        All Right Reserved. 
// /___/   /\   
// \   \  /  \  
//  \___\/\___\ 
////////////////////////////////////////////////////////////////////////////////

#ifndef H_workM_dual_port_ram512x1_H
#define H_workM_dual_port_ram512x1_H

#ifdef _MSC_VER
#pragma warning(disable: 4355)
#endif

#ifdef __MINGW32__
#include "xsimMinGW.h"
#else
#include "xsim.h"
#endif

class workM_dual_port_ram512x1 : public HSim__s5{
public: 
    workM_dual_port_ram512x1(const char *instname);
    ~workM_dual_port_ram512x1();
    void setDefparam();
    void constructObject();
    void moduleInstantiate(HSimConfigDecl *cfg);
    void connectSigs();
    void reset();
    virtual void archImplement();
    void paramAssign();
    HSim__s2 *driver_us0;
    HSim__s2 *driver_us1;
    HSim__s1 us[113];
    HSim__s3 uv[1];
};

#endif
